/**
 * util.h: Various utility functions.
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented in COPYING.
 *
 * $Id: time.h,v 1.1 2007/09/22 14:27:26 pippijn Exp $
 */

#ifndef TIME_H
#define TIME_H

#include <sys/time.h>

typedef double tstamp;

inline tstamp
now ()
{
#ifdef HAVE_GETTIMEOFDAY
  struct timeval tv;

  gettimeofday (&tv, 0);
  return tstamp (tv.tv_sec) + tstamp (tv.tv_usec) * tstamp (1e-6);
#else
  return tstamp (time (0));
#endif
}

/* time stuff */
#ifdef HAVE_GETTIMEOFDAY
extern void s_time (struct timeval *sttime);
extern void e_time (struct timeval sttime, struct timeval *ttime);
extern int tv2ms (struct timeval *tv);
#endif
extern char *time_ago (time_t event);
extern char *timediff (time_t seconds);

#ifndef timersub
inline void
timersub (timeval *tvp, timeval *uvp, timeval *vvp)
{
  vvp->tv_sec = tvp->tv_sec - uvp->tv_sec;
  vvp->tv_usec = tvp->tv_usec - uvp->tv_usec;
  if (vvp->tv_usec < 0)
    {
      vvp->tv_sec--;
      vvp->tv_usec += 1000000;
    }
}
#endif

#endif
